import { Sequence, ConstVar, Func, Var } from '../../../../WebPd_compiler/dist/src/ast/declare.js';
import '../../../../WebPd_compiler/dist/src/compile/precompile/proxies.js';
import '../../../../WebPd_compiler/dist/src/stdlib/fs.js';
import { msg } from '../../../../WebPd_compiler/dist/src/stdlib/msg.js';
import '../../../../WebPd_compiler/dist/src/compile/precompile/nodes.js';
import '../../../../WebPd_compiler/dist/src/compile/proxies.js';

// TODO : unit tests
const signalBuses = () => Sequence([
    ConstVar('Map<string, Float>', 'SIGNAL_BUSES', 'new Map()'),
    `SIGNAL_BUSES.set('', 0)`,
    Func('addAssignSignalBus', [
        Var('string', 'busName'),
        Var('Float', 'value')
    ], 'Float') `
            ${ConstVar('Float', 'newValue', 'SIGNAL_BUSES.get(busName) + value')}
            SIGNAL_BUSES.set(
                busName,
                newValue,
            )
            return newValue
        `,
    Func('setSignalBus', [
        Var('string', 'busName'),
        Var('Float', 'value'),
    ], 'void') `
            SIGNAL_BUSES.set(
                busName,
                value,
            )
        `,
    Func('resetSignalBus', [
        Var('string', 'busName')
    ], 'void') `
            SIGNAL_BUSES.set(busName, 0)
        `,
    Func('readSignalBus', [Var('string', 'busName')], 'Float') `
            return SIGNAL_BUSES.get(busName)
        `
]);
// TODO : unit tests
const messageBuses = {
    codeGenerator: () => Sequence([
        ConstVar('Map<string, Array<MessageHandler>>', 'MSG_BUSES', 'new Map()'),
        Func('msgBusPublish', [Var('string', 'busName'), Var('Message', 'message')], 'void') `
            ${Var('Int', 'i', '0')}
            ${ConstVar('Array<MessageHandler>', 'callbacks', 'MSG_BUSES.has(busName) ? MSG_BUSES.get(busName): []')}
            for (i = 0; i < callbacks.length; i++) {
                callbacks[i](message)
            }
        `,
        Func('msgBusSubscribe', [Var('string', 'busName'), Var('MessageHandler', 'callback')], 'void') `
            if (!MSG_BUSES.has(busName)) {
                MSG_BUSES.set(busName, [])
            }
            MSG_BUSES.get(busName).push(callback)
        `,
        Func('msgBusUnsubscribe', [Var('string', 'busName'), Var('MessageHandler', 'callback')], 'void') `
            if (!MSG_BUSES.has(busName)) {
                return
            }
            ${ConstVar('Array<MessageHandler>', 'callbacks', 'MSG_BUSES.get(busName)')}
            ${ConstVar('Int', 'found', 'callbacks.indexOf(callback) !== -1')}
            if (found !== -1) {
                callbacks.splice(found, 1)
            }
        `
    ]),
    dependencies: [msg],
};

export { messageBuses, signalBuses };
