import { Sequence, Func, Var } from '../../../../WebPd_compiler/dist/src/ast/declare.js';
import '../../../../WebPd_compiler/dist/src/compile/precompile/proxies.js';
import '../../../../WebPd_compiler/dist/src/stdlib/fs.js';
import '../../../../WebPd_compiler/dist/src/compile/precompile/nodes.js';
import '../../../../WebPd_compiler/dist/src/compile/proxies.js';

const EMPTY_BUS_NAME = 'empty';
const build = () => ({
    inlets: {
        '0': { type: 'message', id: '0' },
    },
    outlets: {
        '0': { type: 'message', id: '0' },
    },
    // This is always true, because the object can receive 
    // messages through message bus
    isPushingMessages: true
});
const controlsCore = (ns) => Sequence([
    Func(ns.setReceiveBusName, [
        Var(ns.State, 'state'),
        Var('string', 'busName'),
    ], 'void') `
            if (state.receiveBusName !== "${EMPTY_BUS_NAME}") {
                msgBusUnsubscribe(state.receiveBusName, state.messageReceiver)
            }
            state.receiveBusName = busName
            if (state.receiveBusName !== "${EMPTY_BUS_NAME}") {
                msgBusSubscribe(state.receiveBusName, state.messageReceiver)
            }
        `,
    Func(ns.setSendReceiveFromMessage, [
        Var(ns.State, 'state'),
        Var('Message', 'm'),
    ], 'boolean') `
            if (
                msg_isMatching(m, [MSG_STRING_TOKEN, MSG_STRING_TOKEN])
                && msg_readStringToken(m, 0) === 'receive'
            ) {
                ${ns.setReceiveBusName}(state, msg_readStringToken(m, 1))
                return true

            } else if (
                msg_isMatching(m, [MSG_STRING_TOKEN, MSG_STRING_TOKEN])
                && msg_readStringToken(m, 0) === 'send'
            ) {
                state.sendBusName = msg_readStringToken(m, 1)
                return true
            }
            return false
        `,
    Func(ns.defaultMessageHandler, [Var('Message', 'm')], 'void') ``,
]);

export { EMPTY_BUS_NAME, build, controlsCore };
