import closeSoundStream from './close-sound-stream.js';
import readSoundFile from './read-sound-file.js';
import readSoundStream from './read-sound-stream.js';
import writeSoundFile from './write-sound-file.js';
import writeSoundStream from './write-sound-stream.js';

var index = async (node, messageEvent, settings) => {
    const message = messageEvent.data;
    const { payload } = message;
    if (message.type !== 'fs') {
        throw new Error(`Unknown message type from node ${message.type}`);
    }
    if (payload.functionName === 'onReadSoundFile' ||
        payload.functionName === 'sendReadSoundFileResponse_return') {
        readSoundFile(node, payload, settings);
    }
    else if (payload.functionName === 'onOpenSoundReadStream' ||
        payload.functionName === 'sendSoundStreamData_return') {
        readSoundStream(node, payload, settings);
    }
    else if (payload.functionName === 'onWriteSoundFile' ||
        payload.functionName === 'sendWriteSoundFileResponse_return') {
        writeSoundFile(node, payload, settings);
    }
    else if (payload.functionName === 'onOpenSoundWriteStream' ||
        payload.functionName === 'onSoundStreamData') {
        writeSoundStream(node, payload, settings);
    }
    else if (payload.functionName === 'closeSoundStream_return') {
        writeSoundStream(node, payload, settings);
        readSoundStream(node, payload, settings);
    }
    else if (payload.functionName === 'onCloseSoundStream') {
        closeSoundStream(node, payload);
    }
    else {
        throw new Error(`Unknown callback ${payload.functionName}`);
    }
};

export { index as default };
