import '../../../WebPd_compiler/dist/src/compile/precompile/proxies.js';
import { FS_OPERATION_SUCCESS } from '../../../WebPd_compiler/dist/src/stdlib/fs.js';
import '../../../WebPd_compiler/dist/src/compile/precompile/nodes.js';
import '../../../WebPd_compiler/dist/src/compile/proxies.js';
import { fixSoundChannelCount, resolveRelativeUrl } from '../utils.js';
import fakeFs from './fake-filesystem.js';

/*
 * Copyright (c) 2022-2023 Sébastien Piquemal <sebpiq@protonmail.com>, Chris McCormick.
 *
 * This file is part of WebPd
 * (see https://github.com/sebpiq/WebPd).
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */
var writeSoundFile = async (node, payload, settings) => {
    if (payload.functionName === 'onWriteSoundFile') {
        const [operationId, sound, url, [channelCount]] = payload.arguments;
        const fixedSound = fixSoundChannelCount(sound, channelCount);
        const absoluteUrl = resolveRelativeUrl(settings.rootUrl, url);
        await fakeFs.writeSound(fixedSound, absoluteUrl);
        let operationStatus = FS_OPERATION_SUCCESS;
        node.port.postMessage({
            type: 'fs',
            payload: {
                functionName: 'sendWriteSoundFileResponse',
                arguments: [operationId, operationStatus],
            },
        });
    }
    else if (payload.functionName === 'sendWriteSoundFileResponse_return') ;
};

export { writeSoundFile as default };
