import { BuildSettings, WasmBuffer } from './types';
/**
 * This function sets the assemblyscript compiler so that WebPd can use it.
 * The assemblyscript compiler is quite heavy and causes problems with bundling.
 * Also, depending on the host environment (web or node), it is loaded differently.
 * Therefore we leave it to the consumer to load it themselves and then pass the loaded
 * instance to WebPd.
 */
export declare const setAsc: (asc: any) => any;
export declare const compileAssemblyscript: (code: string, bitDepth: BuildSettings['audioSettings']['bitDepth']) => Promise<WasmBuffer>;
