export type BuildFormat = keyof typeof BUILD_FORMATS;
export type BuildTree = Array<BuildFormat | BuildTree>;
export declare const BUILD_FORMATS: {
    pd: {
        extensions: string[];
        description: string;
    };
    pdJson: {
        extensions: string[];
        description: string;
    };
    dspGraph: {
        extensions: string[];
        description: string;
    };
    javascript: {
        extensions: string[];
        description: string;
    };
    assemblyscript: {
        extensions: string[];
        description: string;
    };
    wasm: {
        extensions: string[];
        description: string;
    };
    wav: {
        extensions: string[];
        description: string;
    };
    app: {
        extensions: string[];
        description: string;
    };
};
export declare const BUILD_TREE: BuildTree;
export declare const guessFormat: (filepath: string) => BuildFormat | null;
export declare const listBuildSteps: (inFormat: BuildFormat, outFormat: BuildFormat, intermediateStep?: BuildFormat) => Array<BuildFormat>;
export declare const listOutputFormats: (inFormat: BuildFormat) => Set<BuildFormat>;
export declare const _findBuildPaths: (branch: BuildTree, target: BuildFormat, parentPath: Array<BuildFormat>) => Array<Array<BuildFormat>>;
export declare const _traverseBuildTree: (branch: BuildTree, parentPath: Array<BuildFormat>) => Array<Array<BuildFormat>>;
