import { DspGraph } from '@webpd/compiler';
import { PdJson } from '@webpd/pd-parser';
import { ControlTree } from '../gui-controls';
interface IoMessageSpecMetadataControlBase {
    group: string;
    type: PdJson.NodeType;
    position: [number, number];
    label?: string;
}
interface IoMessageSpecMetadataControlFloat extends IoMessageSpecMetadataControlBase {
    group: 'control:float';
    initValue: number;
    minValue: number;
    maxValue: number;
}
interface IoMessageSpecMetadataControl extends IoMessageSpecMetadataControlBase {
    group: 'control';
}
interface IoMessageSpecMetadataSend {
    group: 'send';
    name: string;
    position: [number, number];
}
export type IoMessageSpecMetadata = IoMessageSpecMetadataControl | IoMessageSpecMetadataControlFloat | IoMessageSpecMetadataSend;
export declare const collectIoMessageReceiversFromSendNodes: (pdJson: PdJson.Pd, graph: DspGraph.Graph) => import("@webpd/compiler/dist/src/compile/types").IoMessageSpecs;
export declare const collectIoMessageReceiversFromGui: (controls: Array<ControlTree>, graph: DspGraph.Graph) => import("@webpd/compiler/dist/src/compile/types").IoMessageSpecs;
export {};
