import { NodeBuilder, NodeBuilders } from './types';
import { DspGraph } from '@webpd/compiler';
import { PdJson } from '@webpd/pd-parser';
export declare const resolvePatch: (pd: PdJson.Pd, patchId: PdJson.GlobalId) => PdJson.Patch;
export declare const resolvePdNode: (patch: PdJson.Patch, nodeId: PdJson.LocalId) => PdJson.Node;
export declare const resolveNodeType: (nodeBuilders: NodeBuilders, nodeType: PdJson.NodeType) => {
    nodeType: DspGraph.NodeType;
    nodeBuilder: NodeBuilder<any>;
};
/**
 * Takes an object string arg which might contain dollars, and returns the resolved version.
 * e.g. : [table $0-ARRAY] inside a patch with ID 1887 would resolve to [table 1887-ARRAY]
 */
export declare const resolveDollarArg: (arg: string, patch: PdJson.Patch) => PdJson.NodeArg;
export declare const resolveArrayDollarArgs: (rootPatch: PdJson.Patch, args: PdJson.PdArray['args']) => PdJson.PdArray['args'];
export declare const resolvePdNodeDollarArgs: (rootPatch: PdJson.Patch, args: PdJson.NodeArgs) => PdJson.NodeArgs;
