import { DspGraph } from '@webpd/compiler';
import { AudioSettings, CompilerTarget } from '@webpd/compiler/src/compile/types';
import { PdJson } from '@webpd/pd-parser';
import { NodeBuilder, PartialNode } from '../compile-dsp-graph/types';
export declare const SAMPLE_RATE = 44100;
export interface NodeImplementationTestParameters {
    target: CompilerTarget;
    bitDepth: AudioSettings['bitDepth'];
    floatArrayType: typeof Float32Array | typeof Float64Array;
}
export declare const NODE_IMPLEMENTATION_TEST_PARAMETERS: Array<NodeImplementationTestParameters>;
export declare const buildNode: <NodeArgsType>(nodeBuilder: NodeBuilder<NodeArgsType>, type: DspGraph.NodeType, args: NodeArgsType) => DspGraph.Node;
export declare const TEST_PATCH: import("@webpd/pd-parser/src/types").PdJson.Patch;
export declare const TEST_NODE_ID = "0";
export declare const testNodeTranslateArgs: <NodeArguments>(nodeBuilder: NodeBuilder<NodeArguments>, args: PdJson.NodeArgs, expectedNodeArgs: NodeArguments, patch?: import("@webpd/pd-parser/src/types").PdJson.Patch) => void;
export declare const testNodeBuild: <NodeArguments>(nodeBuilder: NodeBuilder<NodeArguments>, nodeArgs: NodeArguments, expectedPartialNode: Partial<PartialNode>) => void;
export declare const testParametersCombine: <T>(key: string, values: ReadonlyArray<any>) => (NodeImplementationTestParameters & T)[];
